
#define BYTE unsigned char
#define BOOLEAN unsigned char
#define SHORT  short
#define USHORT unsigned short
#define DOUBLE double
#define UINT unsigned int
#define HANDLE unsigned int
#define HMODULE unsigned int
#define INT int
#define DWORD unsigned int
#define clock_t long
#define WINAPI __stdcall
#define HINSTANCE unsigned int
#define BOOL int
#define HWND unsigned int
#define LONG int
#define VOID void



typedef VOID (*P_APP_DEV_ADD_REMOVE_NOTIFICATION)(USHORT usDevID, BOOLEAN bAddRem);
     

typedef struct _SCAN_OBJECT_DIO
{
    BYTE			SO_bScanType;
    double			SO_Rate;

    UINT			SO_TotalPointsReadByDrvr;
    UINT			SO_PointsInBuffer;

#define SCAN_RUNNING 						0x01
#define SCAN_DATA_REQUEST_SUCCEEDED			0x02
#define SCAN_ENDING 						0x04
#define SCAN_HALTED 						0x08
#define SCAN_CHECKSUM_ERROR					0x10
#define SCAN_VOLTAGE_BUFFER_WRAP			0x20
#define SCAN_MICRO_CODE_BUFF_WRAP			0x40
#define SCAN_DEVICE_IO_ERROR				0x80
#define SCAN_DEVICE_DISCONNECTED			0x100
#define SCAN_DEVICE_NOT_FOUND				0x200
#define SCAN_AUX_WRITE_PENDING				0x800

#define SCAN_DEVICE_POWER_LOSS				0x1000

    UINT			SO_Status;

    UINT			SO_SizeVoltageArray;
    UINT			SO_CurHead;
    UINT			SO_CurTail;
    BYTE			SO_bDigitalInput;
    BYTE			SO_bChecksum;
    BYTE			SO_DeviceDisconnect; // App sets this if device unplugged

    clock_t			SO_ScanStartTime;
    clock_t			SO_ScanEndTime;

    BYTE			SO_bScanArg;
} SCAN_OBJECT_DIO, *PSCAN_OBJECT_DIO;




/* from http://lawsonlabs.com//Download/Manuals-Drivers/Model_301_302/M30x_SP/Shared/ArchiveContents/_HTML_docs/FunctionUsage/FuncUse.htm
 Connecting
EX_CheckConnect

 Configuration
EX_GetConfiguration
EX_CheckIniExist
EX_SetDevToIniSetup
EX_SetDevToDefaultSetup

EX_SystemCalibration
EX_FullScaleCalibration
EX_OffsetCalibration

 Basic I/O
EX_SendDAC
EX_SendDigout
EX_Digout_Quick
EX_DigoutBitPreserve
EX_GetDigin

 Misc function
EX_GetOneConversion
EX_SetPolledModeChan
EX_SendRate
EX_GetCalculatedRate

 Scanning   ( normal )
EX_SetScanType
EX_GetScanType
EX_SetMultiChanScanChans
EX_GetMultiChanScanChans
EX_SetDataLogOptions
EX_GetDataLogOptions
EX_SetMultiChanScanChans_TO_LOG
EX_GetMultiChanScanChans_TO_LOG
EX_Run
EX_CheckRun
EX_CheckScanStatus
EX_GetScanDataDbl
EX_GetScanDataDblDigin
EX_GetScanDataInt
EX_GetScanDataIntDigin
EX_SetLengthOfRunSec
EX_SetRunEndBeepOptions
EX_Stop
EX_StopComplete
*/

//#####################################################################
//just for testing pass a value, it will increment and return the value
__declspec(dllexport) BOOLEAN EX_ConnectTEST(USHORT* usDevID);
//looks like this:
/*
BOOLEAN EX_ConnectTEST(USHORT* usTestVal)
{
	char buff[32];
	USHORT val = *usTestVal;
	sprintf(buff, "val: %u", *usTestVal);
	MessageBox(GetForegroundWindow(), buff, "MESSAGE FROM DLL ----", 0);
	*usTestVal = val + 1;
	return TRUE;
}
*/
//#####################################################################

//#####################################################################
//#####################################################################
//MOST COMMONLY USED SIMPLIFIED CALLS (START)
//#####################################################################
//#####################################################################
__declspec(dllexport) BOOLEAN EX_SendRateMod(USHORT usDevID, double* dblRate, BOOLEAN fDoThreadEnd);
__declspec(dllexport) BOOLEAN EX_Connect(USHORT* usDevID); 
__declspec(dllexport) BOOLEAN EX_ConnectAllDevices(BYTE* pbNumDevices, USHORT* pDevList, double* dblRates);
__declspec(dllexport) BOOLEAN EX_CheckConnect(USHORT usDevID);

__declspec(dllexport) BOOLEAN EX_SendChan(USHORT usDevID, BYTE bChan, BYTE* pbLastDigin);

__declspec(dllexport) BOOLEAN EX_SetScanSystemBoostVal(USHORT usDevID, BYTE bBoostVal, BOOLEAN fOverride);
__declspec(dllexport) BOOLEAN EX_GetScanSystemBoostVal(USHORT usDevID, BYTE* bBoostVal, BOOLEAN* fOverride);
__declspec(dllexport) BOOLEAN EX_GetRequestedRate(USHORT usDevID, double* dblRate);

__declspec(dllexport) BOOLEAN EX_SetScanAvg(USHORT usDevID, BYTE bAvg);
__declspec(dllexport) BOOLEAN EX_GetScanAvg(USHORT usDevID, BYTE* pbAvg);
__declspec(dllexport) BOOLEAN EX_CheckIniExist(void);
__declspec(dllexport) BOOLEAN EX_SetStackedIRPcnt(USHORT usDevID, BYTE bStackedCnt, BOOLEAN fOverride);
__declspec(dllexport) BOOLEAN EX_GetStackedIRPcnt(USHORT usDevID, BYTE* bStackedCnt, BOOLEAN* fOverride);
__declspec(dllexport) BOOLEAN EX_GetCalculatedRate(USHORT usDevID, double* dblRate);
__declspec(dllexport) BOOLEAN EX_SetScanEndEvent_Mask(USHORT usDevID, BYTE _bBitsToWatch, BYTE _bStateToWatch, BOOLEAN _bStopOnAny, BOOLEAN fUseEventEnd);
__declspec(dllexport) BOOLEAN EX_SetScanEndEvent(USHORT usDevID, BYTE bEvent, BOOLEAN fUseEventEnd);

__declspec(dllexport) void TestFunc(void);

__declspec(dllexport) BOOLEAN EX_CheckScanStatus(USHORT usDevID, UINT* puiNumScansRemainingInBuff, BOOLEAN* pfStillScanning, UINT* puiStatusCode);

__declspec(dllexport) UINT GetWinHandle(void);
__declspec(dllexport) BOOLEAN EX_SetDevToDefaultSetup(USHORT usDevID);
__declspec(dllexport) BOOLEAN EX_SetDevToIniSetup(USHORT usDevID);
__declspec(dllexport) BOOLEAN EX_GetConfiguration(USHORT* pusDevID, BYTE* pbPollChan, BYTE* pbScanType, BYTE* pbChanCnt, double* pdblRate, UINT* puiDataLogMethod);

__declspec(dllexport) BOOLEAN EX_ReConnectOneDev(void);
__declspec(dllexport) BOOLEAN EX_SendRate(USHORT usDevID, double* dblRate);
__declspec(dllexport) BOOLEAN EX_SendDigout(USHORT usDevID, BYTE bDigOut);
__declspec(dllexport) BOOLEAN EX_GetDigin(USHORT usDevID, BYTE* bDigIn);
__declspec(dllexport) BOOLEAN EX_SendChan_Quick(USHORT usDevID, BYTE bChan);
__declspec(dllexport) BOOLEAN EX_Digout_Quick(USHORT usDevID, BYTE bDigOut);
__declspec(dllexport) BOOLEAN EX_DigoutBitPreserve(USHORT usDevID, BOOLEAN fDo, BYTE bPreserve);
__declspec(dllexport) BOOLEAN EX_Digout_Quick_BP(USHORT usDevID, BYTE bDigOut, BYTE bBitPreserve);
__declspec(dllexport) BOOLEAN EX_GetPolledModeChan(BYTE* bMainChan, BYTE* bSubChan);
__declspec(dllexport) BOOLEAN EX_SetPolledModeChan(USHORT usDevID, BYTE bChan);
__declspec(dllexport) BOOLEAN EX_GetOneConversion(USHORT usDevID, double* dblMilliVolts);

// scan start and stop related
__declspec(dllexport) BOOLEAN EX_Run(USHORT usDevID);
__declspec(dllexport) BOOLEAN EX_Stop(USHORT usDevID);
__declspec(dllexport) BOOLEAN EX_EndScan(USHORT usDevID);
__declspec(dllexport) BOOLEAN EX_CheckRun(USHORT usDevID);

// scan channel setup related
__declspec(dllexport) BOOLEAN EX_GetMultiChanScanChans(USHORT usDevID, BYTE* bChanCnt);
__declspec(dllexport) BOOLEAN EX_SetMultiChanScanChans(USHORT usDevID, BYTE bChanCnt);
__declspec(dllexport) BOOLEAN EX_GetMultiChanScanChans_TO_LOG(USHORT usDevID, BYTE* pbScanChansToLog);
__declspec(dllexport) BOOLEAN EX_SetMultiChanScanChans_TO_LOG(USHORT usDevID, BYTE pbScanChansToLog);
__declspec(dllexport) BOOLEAN EX_StopComplete(USHORT usDevID);

// scan data handling related
__declspec(dllexport) BOOLEAN EX_GetScanDataDbl(USHORT usDevID, double* pdblDataBuff, UINT uiNumScansToReturn, BOOLEAN fGetAllRequested, UINT* puiNumScansReturned, UINT* puiNumScansInBuff, BOOLEAN* pfStillScanning, UINT* uiTotalBuffSize, UINT* puiErrCode);
__declspec(dllexport) BOOLEAN EX_GetScanDataDblDigin(USHORT usDevID, double* pdblDataBuff, BYTE* pbDigin, UINT uiNumScansToReturn, BOOLEAN fGetAllRequested, UINT* puiNumScansReturned, UINT* puiNumScansInBuff, BOOLEAN* pfStillScanning, UINT* uiTotalBuffSize, UINT* puiErrCode);
__declspec(dllexport) BOOLEAN EX_GetScanDataInt(USHORT usDevID, INT* piDataBuff, UINT uiNumScansToReturn, BOOLEAN fGetAllRequested, UINT* puiNumScansReturned, UINT* puiNumScansInBuff, BOOLEAN* pfStillScanning, UINT* uiTotalBuffSize, UINT* puiErrCode);
__declspec(dllexport) BOOLEAN EX_GetScanDataIntDigin(USHORT usDevID, INT* piDataBuff, BYTE* pbDigin, UINT uiNumScansToReturn, BOOLEAN fGetAllRequested, UINT* puiNumScansReturned, UINT* puiNumScansInBuff, BOOLEAN* pfStillScanning, UINT* uiTotalBuffSize, UINT* puiErrCode);

// scan type related
__declspec(dllexport) BOOLEAN EX_SetScanType(USHORT usDevID, BYTE bScanType);
__declspec(dllexport) BOOLEAN EX_GetScanType(USHORT usDevID, BYTE bScanType);

// scan logfile related
__declspec(dllexport) BOOLEAN EX_GetDataLogOptions(UINT* uiDataLogMethod, UINT* uiLogFileMaxSize, UINT* uiMisc);
__declspec(dllexport) BOOLEAN EX_SetDataLogOptions(USHORT usDevID, UINT uiDataLogMethod, UINT uiLogFileMaxSize, UINT uiMisc);
__declspec(dllexport) BOOLEAN EX_SetExperimentName(char* pszName);

// scan end notification related
__declspec(dllexport) BOOLEAN EX_SetLengthOfRunMs(USHORT usDevID, UINT uiMilliseconds);
__declspec(dllexport) BOOLEAN EX_SetLengthOfRunSec(USHORT usDevID, UINT uiSeconds);
__declspec(dllexport) BOOLEAN EX_SetRunEndBeepOptions(USHORT usDevID, BOOLEAN _fUseBeep, UINT uiBeepFreqMs, UINT uiBeepDurationMs, UINT uiBeepIntervalSec, UINT uiBeepTimeoutSec);
__declspec(dllexport) BOOLEAN EX_StopRunEndBeep(USHORT usDevID);

// scan debug related
//#####################################################################
//#####################################################################
//MOST COMMONLY USED SIMPLIFIED CALLS (END)
//#####################################################################
//#####################################################################



//START OF OLDER FUNCTIONS
__declspec(dllexport) BOOLEAN EX_CheckVal(BYTE bVal);

//9-12-11
__declspec(dllexport) BOOLEAN Th_ScanDbg(BYTE level, BOOLEAN fOn);

__declspec(dllexport) BOOLEAN SP_DisableDialog(void);
//2-19-09
__declspec(dllexport) BOOLEAN EX_ThreadedInitDev(USHORT usDevID, double dblRate, BYTE bChan, UINT* uiInitStat, BOOLEAN fDeQueue);
__declspec(dllexport) BOOLEAN EX_DLL_Init(HANDLE hMainWin);
__declspec(dllexport) BOOLEAN EX_EndThreadedDevInit(void);
//12-8-08
__declspec(dllexport) BOOLEAN EX_InitAllDevices(USHORT* pDevList, BYTE* pbNumDevices, DOUBLE* pdblDevRate, BOOLEAN fShowDevList);
__declspec(dllexport) BOOLEAN EX_InitOneDevice(USHORT DevID, DOUBLE dblRate, BYTE bChan);
//12-8-08
__declspec(dllexport) BOOLEAN EX_SendChan(USHORT usDevID, BYTE bChan);
__declspec(dllexport) BOOLEAN EX_SetStackedIRPcnt(BYTE bStackedCnt, BOOLEAN fOverride);
__declspec(dllexport) BOOLEAN DLL_GetDriverMemVersionInfo(char* str1, char* str2);
__declspec(dllexport) UINT GetWinHandle(void);
__declspec(dllexport) BOOLEAN SP_GetCalculatedRate(double* dblRate, USHORT usDevID);
__declspec(dllexport) BOOLEAN SP_SendToDebug_AllDevInfoThisApp(void);
__declspec(dllexport) BOOLEAN SP_GetAppDevListInfo(USHORT usAppDevID, USHORT* usDLLDevID, BYTE* bDisonnected, BYTE* bFound, BYTE* bDevIndex);
__declspec(dllexport) BOOLEAN SP_GetAppDevList(USHORT* usCompleteDevList, UINT uiUnused);
__declspec(dllexport) BOOLEAN SP_GetDevOwnershipList(USHORT* usCompleteDevList, HANDLE* puiAppHandleList);
__declspec(dllexport) BOOLEAN SP_SendEndScanToken(USHORT usDevID);
__declspec(dllexport) BOOLEAN SP_GetEndScanStatus(USHORT usDevID, UINT* puiEndScanFlags);
__declspec(dllexport) BOOLEAN SP_InitOneDev(USHORT usDevID, DOUBLE* dblRate, BYTE bChan);
//12-3-08 this function is exported as of this date and the
// one above is removed from the .def file since it's improperly
// named. There doesn't appear to be any sample applications using
// it and it doesn't appear to be in any of the docs.
__declspec(dllexport) BOOLEAN SP_ReInitOneDev(USHORT usDevID, DOUBLE* dblRate, BYTE bChan);
__declspec(dllexport) int Net_TestDLL(BYTE bVal);
__declspec(dllexport) int Net_TestDLL2(BYTE *pDevList);
__declspec(dllexport) BOOLEAN DLL_ReturnDeviceStringsInfo(char* pszString, USHORT usDevID);
__declspec(dllexport) BOOLEAN DLL_DoMiscDevIOWrite(USHORT usDevID);

__declspec(dllexport) BOOLEAN SP_ResetDevice(USHORT usDevID);
__declspec(dllexport) BOOLEAN SPx_ScanUtilityParams(UINT* puiUtilityScanParams);
__declspec(dllexport) BOOLEAN SP_WriteWhileScanning(USHORT usDevID, BYTE bCmnd, BYTE bArg, UINT* puiCurWriteStat);
__declspec(dllexport) BOOLEAN SP_GetDLL_ExpectedDriverVerString(char* pszInfo);
__declspec(dllexport) BOOLEAN SP_GetDLL_ExpectedDriverVerMnthDayYearMisc(
    USHORT* usDevDrvVerMnth, USHORT* usDevDrvVerDay,
    USHORT* usDevDrvVerYear, USHORT* usDevDrvVerMisc);
__declspec(dllexport) BOOLEAN SP_GetDLL_CompilationInfo(char* pszInfo);
__declspec(dllexport) BOOLEAN SP_GetDLL_Version(char* pszInfo);
__declspec(dllexport) BOOLEAN SP_GetDLL_Directory(char* pszInfo, USHORT usBuffSize);
__declspec(dllexport) BOOLEAN DLL_DoNothingFunc(BYTE bVal, USHORT usVal, DOUBLE* dblArray);
__declspec(dllexport) BOOLEAN SP_GetRegDevList(USHORT* usCompleteDevList, UINT uiUnused);
__declspec(dllexport) BOOLEAN SP_GetAppDevCnt(BYTE* pbDevCnt);
__declspec(dllexport) BOOLEAN SP_InitAllDevices_Thread(USHORT* pDevList, DOUBLE* pdblDevRate, BOOLEAN fShowDevList);
__declspec(dllexport) BOOLEAN SP_CancelInitThread(void);
__declspec(dllexport) BOOLEAN SP_GetInitThreadStat(void);
__declspec(dllexport) BOOLEAN SP_GetLastInitStat(USHORT* pDevList, UINT* puiFlags);
__declspec(dllexport) BOOLEAN SP_GetLastInitDevAndRates(USHORT* pDevList, double* pdblRates);
__declspec(dllexport) BOOLEAN SP_CalcRateCodes(BYTE* bLow, BYTE* bMid, BYTE* bHigh, USHORT usDevID, DOUBLE* dlbDevRate);
__declspec(dllexport) BOOLEAN SP_InitDLL(VOID); //NOTE: LabView
__declspec(dllexport) BOOLEAN SP_InitAllDevices(USHORT* pDevList, BYTE* pbNumDevices_LV, DOUBLE* dblRate, BOOLEAN fShowDevList);
__declspec(dllexport) BOOLEAN SP_SendRate(DOUBLE* dblRate, USHORT usDevID);
__declspec(dllexport) BOOLEAN SP_SystemCalibration(USHORT usDevID, BYTE bCurChan);
__declspec(dllexport) BOOLEAN SP_SendChan(USHORT usDevID, BYTE bCurChan, BYTE* pbLastDigin);
__declspec(dllexport) BOOLEAN SP_SendReset(USHORT usDevID, BYTE bCurChan, BYTE* pbLastDigin);
__declspec(dllexport) BOOLEAN SP_GetOneConversion(USHORT usDevID, UINT* uiConvRawCount, BYTE bCurChan, BYTE* pbLastDigin);
__declspec(dllexport) BOOLEAN SP_SendDigOut(USHORT usDevID, BYTE bDigOut, BYTE* pbLastDigin);
__declspec(dllexport) BOOLEAN SP_ReadWriteOneDevice(BOOLEAN fReadWrite, BYTE* DynamicDataArray, USHORT usDevID, UINT* numBytes, BYTE* pbDigIn, BYTE bCurChan, UINT* _puiFlags);
__declspec(dllexport) BOOLEAN SP_SendDAC(USHORT usDevID, DOUBLE dblVoltage, BYTE bDAC, BYTE* pbReserved);
__declspec(dllexport) BOOLEAN SP_StartScan(USHORT usDevID, DOUBLE* dblScanObject);
__declspec(dllexport) BOOLEAN SP_ReadScanData(USHORT usDevID, USHORT numPointsToRead, UINT* DynaVoltageBuff, DOUBLE* dblScanObject);
__declspec(dllexport) BOOLEAN SP_ReadScanDataWithDigin(USHORT usDevID, UINT* DynaVoltageBuff, BYTE* bDiginBuff, BYTE* pbCurChan, USHORT numPointsToRead, DOUBLE* dblScanObject);
__declspec(dllexport) BOOLEAN SP_EndScan(USHORT usDevID);
__declspec(dllexport) BOOLEAN SP_DrvrDebugOutput(USHORT usDevID, UINT uiDbgFlags, char* pszMsg, USHORT usMsgLngth);
__declspec(dllexport) BOOLEAN SP_SetProcessPriorityBoost(BYTE bBoost);
__declspec(dllexport) BOOLEAN SP_GetDevStat(USHORT usDevID, UINT* _uiDevStat);
__declspec(dllexport) BOOLEAN SP_GetDevStatEx(UINT* _uiDevStat, USHORT* _pusAllDevList, BYTE* bNumDevices);
__declspec(dllexport) BOOLEAN SP_CheckPower(USHORT usDevID, BYTE bCurChan, BYTE* pbLastDigin, UINT* puiFlags);

//BOOL WINAPI DllEntryPoint(HINSTANCE hInst, unsigned long reason, void* vptr);
__declspec(dllexport) BOOLEAN DLL_Init(HWND _hAppMainWin, HMODULE _hLibSETUPAPI, HMODULE _hLibUSER32, SHORT sDebugLevel, BYTE* _pNumDevices, BYTE *_pDeviceStatus, USHORT *_pLLABS_DeviceIDList);
__declspec(dllexport) BOOLEAN DLL_Init_301x(HWND _hAppMainWin, HMODULE _hLibSETUPAPI, HMODULE _hLibUSER32, SHORT sDebugLevel, BYTE* _pNumDevices, BYTE *_pDeviceStatus, USHORT *_pLLABS_DeviceIDList);
__declspec(dllexport) BOOLEAN DLL_Init_302x(HWND _hAppMainWin, HMODULE _hLibSETUPAPI, HMODULE _hLibUSER32, SHORT sDebugLevel, BYTE* _pNumDevices, BYTE *_pDeviceStatus, USHORT *_pLLABS_DeviceIDList);

__declspec(dllexport) BOOLEAN DLL_ShowGlobalDevIDList(char* pDevListBuff);
__declspec(dllexport) BOOLEAN DLL_GetDeviceIDList(VOID);
__declspec(dllexport) BOOLEAN DLL_ReInitOneDev(USHORT usDevID);
__declspec(dllexport) BOOLEAN DLL_MarkOneDevAsInUse(USHORT usDevID);
__declspec(dllexport) BOOLEAN DLL_InstanceInitDeviceList(BOOLEAN fShowLists);
__declspec(dllexport) BOOLEAN DLL_ReleaseDeviceFromIDList(USHORT* LLABSDeviceIDList, BOOLEAN fAnyHandle);
__declspec(dllexport) BOOLEAN DLL_UpdateDeviceStatArray(USHORT usDevID, BYTE bStat);
__declspec(dllexport) BOOLEAN DLL_ShowDeviceDescriptor(char* DynamicDeviceDescArray, USHORT usDevID);
__declspec(dllexport) BOOLEAN DLL_ShowConfigurationDescriptor(char* DynamicConfigArray, USHORT usDevID);
__declspec(dllexport) BOOLEAN DLL_ShowInterfaceDescriptors(BYTE* pDynamicArray, USHORT usDevID);
__declspec(dllexport) BOOLEAN DLL_ShowEndpointDescriptors(BYTE* DynamicEndpointDescArray, USHORT usDevID, SHORT whichEndpoint);
__declspec(dllexport) BOOLEAN DLL_ReadWriteOneDevice(BOOLEAN fReadWrite, BYTE* DynamicDataArray, USHORT usDevID, UINT* numBytes, BYTE* pbDigIn, UINT uiReserved);
__declspec(dllexport) BOOLEAN DLL_ReadWriteAllDevices(BOOLEAN fReadWrite, BYTE* pDynamicArray, UINT* numBytes);
__declspec(dllexport) BOOLEAN DLL_SetRate(USHORT usDevID, DOUBLE dblRate);

__declspec(dllexport) BOOLEAN DLL_RunScan_DIO(USHORT usDevID, PSCAN_OBJECT_DIO pScanObj_DIO);
__declspec(dllexport) BOOLEAN DLL_EndScan_DIO(USHORT usDevID, BOOLEAN fEmptyBuffer, UINT uiTimeOut_ms, BYTE bScanPauseOrTerminate);
__declspec(dllexport) BOOLEAN DLL_StartScan_DIO(USHORT usDevID, PSCAN_OBJECT_DIO pScanObj_DIO, BYTE bStartMode);
__declspec(dllexport) BOOLEAN DLL_ReadScanData_DIO(USHORT usDevID, UINT* DynaVoltageBuff, USHORT numPointsToRead, PSCAN_OBJECT_DIO pScanObj_DIO);
__declspec(dllexport) BOOLEAN DLL_ReadScanDataWithDigin(USHORT usDevID, UINT* DynaVoltageBuff, BYTE* bDiginBuff, BYTE* pbCurChan, USHORT numPointsToRead, PSCAN_OBJECT_DIO pScanObj_DIO);
__declspec(dllexport) BOOLEAN DLL_GetEndOfScanBuffSize(USHORT usDevID, UINT* uiNumPoints);
__declspec(dllexport) BOOLEAN DLL_ReadEndOfScanData(USHORT usDevID, UINT* DynaVoltageBuff, USHORT numPointsToRead);
__declspec(dllexport) BOOLEAN DLL_SetSpecialScanFeatures(USHORT usDevID, UINT fFlags);
__declspec(dllexport) BOOLEAN DLL_GetDriverScanData_IOCTL(BYTE bWhichDevice);
__declspec(dllexport) BOOLEAN DLL_GetDrvrTimings(USHORT usDevID);

__declspec(dllexport) BOOLEAN DLL_ResetDevice(USHORT usDevID, BYTE bReserved);
__declspec(dllexport) BOOLEAN DLL_ResetPipe(USHORT usDevID, BYTE bReserved, BOOLEAN fRead);
//__declspec(dllexport) BOOLEAN DLL_CloseDEV(HANDLE hDev);
__declspec(dllexport) BOOLEAN DLL_Device_GetLastStatus(BYTE whichDevice, HANDLE hDEV, LONG* lNtStatus, char* pMsgBuff);

// TIM NOTE: This is ONLY for in-shop use. The device driver clears
//  the array every time that it loads the first device, which is the
//  safest thing to do. If the following call is made and there are
//  any devices connected, then problems with the lists could occur.
__declspec(dllexport) BOOLEAN DLL_RegistryDeviceClean(VOID);

__declspec(dllexport) BOOLEAN DLL_ZeroSharedDevArray(VOID);
__declspec(dllexport) BOOLEAN DLL_ShowSharedDevArray(VOID);
__declspec(dllexport) BOOLEAN DLL_ShowSharedGUIDStringArray(VOID);
__declspec(dllexport) BOOLEAN DLL_GetDevVersion(USHORT usDevID, USHORT* usDevVersion, BOOLEAN fDisplayVersion);
__declspec(dllexport) BOOLEAN DLL_GetVersionInfo(USHORT usDevID, BOOLEAN fDisplayVersion, USHORT* usDevVersion, char* cpDLLVersion, char* cpDrvrVersion);

//===========================================================================
//==== N O   L O N G E R    U S E D    F U N C T I O N S ====================
//===========================================================================
// Keep for backward compatibility.

// following no longer used only kept for backward compatibility, but always return TRUE
__declspec(dllexport) BOOLEAN DLL_SetAppMessaging_VB(BOOLEAN fEnable, HANDLE _hAppMainWin);
//__declspec(dllexport) BOOLEAN DLL_SetDevMngmtCallback(BOOLEAN fEnable, P_APP_DEV_ADD_REMOVE_NOTIFICATION _pDevMngmtCallback, UINT uiNotificationType, USHORT* pusAvailDevArray);






